#ifndef __SLIDEPATH_H__
#define __SLIDEPATH_H__

#include "slideprimitive.h"

class CSLIDENode;

//////////////////////////////////////////////////////////////////////
// CSLIDEPath Class
//

class CSLIDEPath : public CSLIDEPrimitive
{
//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDEPath();
  virtual ~CSLIDEPath();

  virtual VOID Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, 
		    CListInt *plistPathIDs);
  virtual VOID Uninit();

  virtual BOOL Initialized();

  virtual BOOL CheckSemantics(CSLIDEWorld *pCSLIDEWorld);
  virtual CSLIDENode *FindNode(CSLIDENode *pRoot, CListIterInt *piterIDs, 
			       CListInt *plistCSLIDEInstance) = 0;

  virtual BOOL Valid();

//////////////////////////////////////////////////
// Geometric Computations
//
public:

protected:
  virtual VOID CheckDynamic();
  virtual VOID UpdateState();

//////////////////////////////////////////////////
// Rendering
//
public:

//////////////////////////////////////////////////
// Output Functions
//
public:
  virtual VOID WriteSLIDE(FILE *fpOutputFile);

//////////////////////////////////////////////////
// Accessor Functions
//
public:

//////////////////////////////////////////////////
// Class Variables
//
public:

//////////////////////////////////////////////////
// Member Variables
//
protected:
  CListInt *m_plistPathIDs;
  
  CSLIDENode *m_pRoot;
  CListInt m_listCSLIDEInstance;
  CSLIDENode *m_pNode;
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

#endif // __SLIDEPATH_H__


