#include "sliderotate.h"

//////////////////////////////////////////////////////////////////////
// CSLIDERotate Class
//

CSLIDERotate::CSLIDERotate()
{
  m_vAxis.Set(0.0, 0.0, 1.0);
}

CSLIDERotate::~CSLIDERotate()
{
}

VOID CSLIDERotate::Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, 
			DynVector *pdynvAxis, DynFloat *pdynfTheta)
{
  CSLIDETransform::Init(pcFile, uiLine, uiColumn);

  ASSERT( pdynvAxis != NULL );
  ASSERT( pdynfTheta != NULL );

  m_vAxis.SetAll(pdynvAxis);
  m_dynfTheta.Set(pdynfTheta);
}

VOID CSLIDERotate::Uninit()
{
  CSLIDETransform::Uninit();
}

BOOL CSLIDERotate::Initialized()
{
  return CSLIDETransform::Initialized();
}

BOOL CSLIDERotate::CheckSemantics(CSLIDEWorld *pCSLIDEWorld)
{
  if ( !CSLIDETransform::CheckSemantics(pCSLIDEWorld) )
    {
      return FALSE;
    }

  return TRUE;
}

BOOL CSLIDERotate::Valid()
{
  if ( !CSLIDETransform::Valid() )
    {
      return FALSE;
    }

  return TRUE;
}

////////////////////////////////////////////////////////////////////////
// START: ASSIGNMENT 3: Fill these in
// 
VOID CSLIDERotate::CheckDynamic()
{
}

VOID CSLIDERotate::UpdateState()
{
  m_vAxis.Update();
  // Set the transform matrix and its inverse
}
// 
// END  : ASSIGNMENT 3: Fill these in
////////////////////////////////////////////////////////////////////////

VOID CSLIDERotate::WriteSLIDE(FILE *fpOutputFile)
{
  ASSERT( fpOutputFile != NULL );

  fprintf(fpOutputFile, "    %s ( %.3f %.3f %.3f ) ( %.3f )\n", 
	  gcppcSLIDEReservedWords[sliderwtRotate],
	  m_vAxis[X], m_vAxis[Y], m_vAxis[Z], 
	  RADTODEG(m_dynfTheta.GetValue()));
}
